SystemOrganization addCategory: #TusLibros!

Object subclass: #Carrito
	instanceVariableNames: 'catalogo canasto'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Carrito class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 5/29/2013 20:58'!
invalidElementError
	self error: self invalidElementMessage.! !

!Carrito class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 5/29/2013 21:22'!
invalidElementMessage
	^'No se puede agregar algo que no pertenece al catalogo'.! !

!Carrito class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 5/29/2013 21:17'!
newWithThisCatalog: aCatalog
	^self new initializeWith: aCatalog. ! !

!Carrito methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 5/29/2013 20:55'!
add: unElemento
	
	self add: 1 of: unElemento.
! !

!Carrito methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/3/2013 18:41'!
add: aSmallInteger of: anObject 
	catalogo at: anObject  ifAbsent:  [self class invalidElementError].
	"(catalogo includes: anObject) ifFalse: [self class invalidElementError]."
	canasto add: anObject  withOccurrences: aSmallInteger.! !

!Carrito methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 5/29/2013 20:43'!
amountOf: anObject 
	^canasto occurrencesOf: anObject .! !

!Carrito methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 5/29/2013 20:41'!
includes: anObject 
	^canasto includes: anObject .! !

!Carrito methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 5/29/2013 21:18'!
initialize 
	canasto := Bag new.

	^self.! !

!Carrito methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 5/29/2013 21:18'!
initializeWith: aCatalog 
	
	catalogo := aCatalog .
	^self.! !

!Carrito methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 5/29/2013 20:35'!
isEmpty
	^canasto isEmpty.! !

!Carrito methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 5/29/2013 20:49'!
size
	^canasto size.! !

Object subclass: #Cashier
	instanceVariableNames: 'catalog'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Cashier class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/3/2013 18:38'!
invalidCreditCardMessage
	^'La tarjeta no sirve!!!!   pobre'.! !

!Cashier class methodsFor: 'as yet unclassified' stamp: 'ebastian 5/30/2013 22:50'!
newWithThisCatalog: aDictionary 
	^self new initializeWith: aDictionary.! !

!Cashier class methodsFor: 'as yet unclassified' stamp: 'ebastian 6/2/2013 14:41'!
noProductsInCartMessage
	^'No hay productos en el carrito para vender'.! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'ebastian 5/30/2013 22:09'!
initializeWith: aDictionary 
	catalog := aDictionary.
	^self.! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/3/2013 18:48'!
isThisAValidCC: aCC 
	^((aCC owner ~= '')  and: (aCC creditCardNumber > 0)) and: (aCC expiration >= Date today month).! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/3/2013 18:37'!
sellProducts: aCart withThisCreditCard: aCC
	
	(aCart isEmpty ) ifTrue: [self error: Cashier noProductsInCartMessage].
	(self isThisAValidCC:  aCC  ) ifFalse: [ self error: Cashier invalidCreditCardMessage ].
	^true.! !

Object subclass: #CreditCard
	instanceVariableNames: 'owner creditCardNumber expiration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!CreditCard class methodsFor: 'as yet unclassified' stamp: 'ebastian 5/30/2013 22:05'!
newName: aByteString ccNumber: aSmallInteger expiration: month 
	^self new initializeWithName: aByteString ccNumber: aSmallInteger expiration: month.! !

!CreditCard methodsFor: 'as yet unclassified' stamp: 'ebastian 6/2/2013 12:54'!
creditCardNumber
	^ creditCardNumber.! !

!CreditCard methodsFor: 'as yet unclassified' stamp: 'ebastian 5/30/2013 22:59'!
expiration
	
	^ expiration! !

!CreditCard methodsFor: 'as yet unclassified' stamp: 'ebastian 6/2/2013 12:55'!
initializeWithName: aByteString ccNumber: aSmallInteger expiration: month 
	owner := aByteString.
	creditCardNumber := aSmallInteger.
	expiration := month.
	^self.! !

!CreditCard methodsFor: 'as yet unclassified' stamp: 'ebastian 6/2/2013 12:54'!
owner
	^owner.! !

TestCase subclass: #EditorialTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!EditorialTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/3/2013 17:59'!
anOldMonth
	"un mes de un ao que ya hayan pasado"
	^Date today month previous.! !

!EditorialTest methodsFor: 'carritoIntansce' stamp: 'SebastianGarbi 6/3/2013 18:48'!
carrito
	|catalogo|
	catalogo := self catalog .
	catalogo at: self libro put: 12.
	^Carrito newWithThisCatalog: catalogo.
	! !

!EditorialTest methodsFor: 'carritoIntansce' stamp: 'SebastianGarbi 5/29/2013 21:26'!
carrito: unCatalogo
	^Carrito newWithThisCatalog: unCatalogo.
	! !

!EditorialTest methodsFor: 'as yet unclassified' stamp: 'ebastian 5/30/2013 22:49'!
cashier: aDictionary 
	^Cashier newWithThisCatalog: aDictionary.! !

!EditorialTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/3/2013 18:43'!
catalog
	^Dictionary new.! !

!EditorialTest methodsFor: 'as yet unclassified' stamp: 'ebastian 5/30/2013 21:39'!
emptyCatalog
	^Dictionary new.! !

!EditorialTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/3/2013 18:27'!
expiredCC
	^CreditCard newName: 'juan Perez' ccNumber: 12 expiration: self anOldMonth.! !

!EditorialTest methodsFor: 'libroinstances' stamp: 'SebastianGarbi 5/29/2013 19:54'!
libro
	^Object new.! !

!EditorialTest methodsFor: 'libroinstances' stamp: 'SebastianGarbi 5/29/2013 19:57'!
libroDeOtroCatalogo
	^Object new.! !

!EditorialTest methodsFor: 'libroinstances' stamp: 'SebastianGarbi 5/29/2013 19:44'!
otroLibro
	^Object new.! !

!EditorialTest methodsFor: '01- Carrito' stamp: 'SebastianGarbi 5/27/2013 21:09'!
test01CarritoShouldBeEmptyAfterCreation
	self assert: (self carrito isEmpty). ! !

!EditorialTest methodsFor: '01- Carrito' stamp: 'SebastianGarbi 6/3/2013 18:43'!
test02CarritoMustHaveABookAfterAdding
	|unCarrito unLibro unNumero unCatalogo|
	unLibro := self libro.
	unCatalogo := self catalog .
	unCatalogo at: unLibro put: 1.
	unCarrito := self carrito: unCatalogo.
	unNumero := 1.
	
	unCarrito add:  unNumero of: unLibro . 
	self deny:  (unCarrito ) isEmpty. 
	self assert:  (unCarrito includes: unLibro). 
	self assert:  ((unCarrito amountOf: unLibro) = unNumero).! !

!EditorialTest methodsFor: '01- Carrito' stamp: 'SebastianGarbi 6/3/2013 18:44'!
test03CanIncreaseBookQuantity
	|unCarrito unLibro unNumero unCatalogo |
	unLibro := self libro.
	unCatalogo := self catalog  .
	unCatalogo at: unLibro put: 12.
	unCarrito := self carrito: unCatalogo.
	unNumero := 1.
	
	
	
	
	
	unCarrito add: unNumero of: unLibro   .
	unCarrito add: unNumero of: unLibro   .

	 
	self assert:  ((unCarrito amountOf: unLibro) = (unNumero * 2)).! !

!EditorialTest methodsFor: '01- Carrito' stamp: 'SebastianGarbi 6/3/2013 18:45'!
test04CanAddDifferentBooks
	|unCarrito unLibro otroLibro unNumero unCatalogo |
	unLibro := self libro.
	otroLibro := self otroLibro.
	
	unCatalogo := self catalog  .
	unCatalogo at: unLibro put: 12.
	unCatalogo at: otroLibro put: 13.
	unCarrito := self carrito: unCatalogo.
	unNumero := 1.
	
	
	
	unCarrito add: unNumero of: unLibro  .
	unCarrito add: unNumero of: otroLibro  .
	
	
	 
	self assert: (unCarrito includes: unLibro).
	self assert: (unCarrito includes: otroLibro).! !

!EditorialTest methodsFor: '01- Carrito' stamp: 'SebastianGarbi 6/3/2013 18:45'!
test05AddingDifferentBooksRespectQuantities
	|unCarrito unLibro otroLibro unNumero otroNumero unCatalogo |
	unLibro := self libro.
	otroLibro := self otroLibro.
	
	unCatalogo := self catalog  .
	unCatalogo at: unLibro  put: 12.
	unCatalogo at: otroLibro put: 12.
	unCarrito := self carrito: unCatalogo.

	
	
	unNumero := 5.
	otroNumero := 4.
	
	unCarrito add: unNumero of: unLibro  .
	unCarrito add: otroNumero of: otroLibro  .
	
	
	
	 
	self assert: (unCarrito amountOf: unLibro ) = unNumero .
	self assert: (unCarrito amountOf: otroLibro) = otroNumero .
	
	self assert: unCarrito size = (unNumero + otroNumero ).! !

!EditorialTest methodsFor: '01- Carrito' stamp: 'SebastianGarbi 6/3/2013 18:46'!
test06CarritoCanOnlyTakeCatalogBooks
	|unCarrito|
	unCarrito := self carrito .
	self should: [unCarrito add: self libroDeOtroCatalogo. self fail.] raise: Error withExceptionDo: [ :anError | self assert: anError  messageText  = Carrito invalidElementMessage .  
	self assert:  unCarrito isEmpty ].
	
	
	
! !

!EditorialTest methodsFor: '02- Cashier' stamp: 'SebastianGarbi 6/3/2013 18:27'!
test07CashierDontSellAnEmptyCart
	
	| aCC aCashier aCatalog aCart |
	
	aCatalog := self emptyCatalog.
	aCC := self expiredCC.
	aCashier := self cashier: aCatalog.
	aCart := self carrito: aCatalog.
	
	self should: [aCashier sellProducts: aCart withThisCreditCard: aCC ] raise: Error withExceptionDo: [ :anError | 
		self assert: anError  messageText  = Cashier noProductsInCartMessage .  
		self assert:  aCart isEmpty ].
	  
	! !

!EditorialTest methodsFor: '02- Cashier' stamp: 'SebastianGarbi 6/3/2013 18:52'!
test08ASellWithanInvalidCreditCardShouldRaiseAnError
	| aCC aCashier aCatalog aCart unLibro |
	
	unLibro := self libro.
	aCatalog := self emptyCatalog.
	aCatalog at: unLibro put: 10.
	aCC := self expiredCC.
	aCashier := self cashier: aCatalog.
	aCart := self carrito: aCatalog.
	aCart add: 1 of: unLibro .
	
	
	self should: [aCashier sellProducts: aCart withThisCreditCard: aCC . self fail.] raise: Error withExceptionDo: [ :anError | 
		self assert: anError  messageText  = Cashier invalidCreditCardMessage ].! !
